//Come GATO
//Version Analogica
//Juan Galaz
//SETA43
//http: / / seta43.duckdns.org
//http: / / seta43.blogspot.com
//21/11/2022


int vueltas;  //Vueltas por toma
long segundosToma; //Segundos toma

int vueltasA,segundosTomaA;


//------------PINS-----
#define paso  3      
#define direccion  2 
#define enablePin 13
#define PULSADOR 6
#define PARPADEO 9
//---------------------
int Tpaso=800;  //velocidad

void esperaSEG(long segundos)
{
  unsigned long t;
  unsigned char estado;

    for(t=0;t<segundos;t++)
      {
        delay(500);
        if(digitalRead(PULSADOR)==0){ printTitulo(); return;}
        delay(500);
        if(digitalRead(PULSADOR)==0){ printTitulo(); return;}
        if(estado==LOW)
          estado=HIGH;
         else
          estado=LOW;
        digitalWrite(PARPADEO,estado);
      }
}

void printTitulo(void)
{
 int horasToma;
  Serial.println("-----gatoCome------");
  vueltasA= analogRead(A0);
  segundosTomaA=analogRead(A1); 
  Serial.print("A0-Tiempo ="); Serial.println(segundosTomaA);
  Serial.print("A1-Vueltas="); Serial.println(vueltasA); 
  vueltas=vueltasA/100;   vueltas++;
  horasToma=segundosTomaA/41;  
  Serial.print("Horas entre toma="); Serial.println(horasToma); 
  segundosToma=horasToma;  segundosToma*=3600;
  if(horasToma==0)segundosToma=60;
  Serial.print("Segundos entre toma="); Serial.println(segundosToma);
  Serial.print("Vueltas por toma="); Serial.println(vueltas); 
  Serial.println("=====================");
}

void setup() 
{
  Serial.begin(9600);
  delay(100);
  printTitulo();
  
  pinMode(paso, OUTPUT);  
  pinMode(direccion, OUTPUT);  
  digitalWrite(direccion, HIGH); //HIGH=izquierda  LOW=derecha 
  pinMode(PULSADOR,INPUT_PULLUP);
  digitalWrite(PULSADOR,HIGH);
  pinMode(PARPADEO, OUTPUT);
   
}

void loop() 
{
int i,v;
    digitalWrite(enablePin, LOW);
    for (v=0;v<vueltas;v++)
      {
        for( i = 0; i < 200; i++)
        {   
          digitalWrite(paso, HIGH);       
          delayMicroseconds(Tpaso);          
          digitalWrite(paso, LOW);       
          delayMicroseconds(Tpaso);          
        }
      }
    digitalWrite(enablePin, HIGH);
 
  esperaSEG(segundosToma);

}
